=== debian/changelog ===
sdl2-compat (2.32.56+git20251003~dbb14db+ds-1) experimental; urgency=medium

  * New upstream snapshot, commit release-2.32.56-42-gdbb14db
  * Populate REVISION.txt with `git describe` output, making the result
    more similar to what will appear in stable releases

 -- Simon McVittie <smcv@debian.org>  Sat, 04 Oct 2025 14:21:16 +0100
