## sdl2-compat 2.32.56+git20251027~3ecd089+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -87,6 +87,7 @@
 option(SDL2COMPAT_ASAN "Use AddressSanitizer to detect memory errors" OFF)
 option(SDL2COMPAT_STATIC "Enable building static SDL2 link library" OFF)
 option(SDL2COMPAT_WERROR "Treat warnings as errors" OFF)
+option(SDL2COMPAT_X11 "Enable X11 support" ON)
 set(SDL2COMPAT_VENDOR_INFO "" CACHE STRING "Vendor name and/or version to add to SDL_REVISION")
 set(SDL2COMPAT_FRAMEWORK FALSE)
 #FIXME: should SDL2-compat modify vendor_info/revision information?
@@ -224,11 +225,6 @@
   src/dynapi/SDL_dynapi.c
 )
 
-if(UNIX AND NOT ANDROID)
-  find_package(X11 REQUIRED)
-  include_directories(${X11_INCLUDE_DIR})
-endif()
-
 if(APPLE)
   list(APPEND SDL2COMPAT_SRCS
     "src/sdl2_compat_objc.m"
@@ -324,3 +320,4 @@
 if(NOT HAVE_IMMINTRIN_H)
   set(EXTRA_CFLAGS "${EXTRA_CFLAGS} -DSDL_DISABLE_IMMINTRIN_H")
 endif()
+set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${EXTRA_CFLAGS}")
