=== debian/changelog ===
sdl2-compat (2.32.56+git20251027~3ecd089+ds-1) experimental; urgency=medium

  * New upstream snapshot, commit release-2.32.56-61-g3ecd089
  * d/source/lintian-overrides: Update

 -- Simon McVittie <smcv@debian.org>  Mon, 27 Oct 2025 15:15:19 +0000
