=== debian/rules ===
--- 
+++ 
@@ -33,8 +33,8 @@
 	dh $@ -Scmake+ninja -Bcmake-build
 
 override_dh_auto_configure:
-ifeq ($(DEB_VERSION_UPSTREAM),2.32.56+git20251003~dbb14db+ds)
-	echo release-2.32.56-42-gdbb14db > REVISION.txt
+ifeq ($(DEB_VERSION_UPSTREAM),2.32.56+git20251027~3ecd089+ds)
+	echo release-2.32.56-61-g3ecd089 > REVISION.txt
 endif
 	dh_auto_configure -- $(configure_options)
