## sdl2-compat 2.32.56+git20251027~cec43be+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -2,7 +2,7 @@
 #        you can define SDL3_INCLUDE_DIRS on the cmdline.  For example:
 #        cmake -DSDL3_INCLUDE_DIRS=/opt/SDL3/include [other stuff ....]
 
-cmake_minimum_required(VERSION 3.0...3.28)
+cmake_minimum_required(VERSION 3.0...4.1)
 project(sdl2_compat VERSION 2.32.57 LANGUAGES C)
 
 if(POLICY CMP0074)
