=== debian/changelog ===
sdl2-compat (2.32.56+git20251027~cec43be+ds-1) experimental; urgency=medium

  * New upstream snapshot, commit release-2.32.56-62-gcec43be

 -- Simon McVittie <smcv@debian.org>  Mon, 27 Oct 2025 20:45:42 +0000
