## sdl2-compat 2.32.56+git20251029~ee7cf25+ds

=== debian/changelog ===
sdl2-compat (2.32.56+git20251029~ee7cf25+ds-1) experimental; urgency=medium

  * New upstream snapshot, commit release-2.32.56-63-gee7cf25

 -- Simon McVittie <smcv@debian.org>  Thu, 30 Oct 2025 13:02:15 +0000
