=== test/CMakeLists.txt ===
--- 
+++ 
@@ -115,12 +115,16 @@
 elseif(WIN32)
   set(TESTNATIVE_EXTRA "testnativew32.c")
 elseif(UNIX AND NOT ANDROID)
-  find_package(X11 REQUIRED)
-  set(TESTNATIVE_EXTRA "testnativex11.c")
+  if(NOT SDL2COMPAT_DISABLE_X11)
+    find_package(X11 REQUIRED)
+    set(TESTNATIVE_EXTRA "testnativex11.c")
+  endif()
 endif()
 test_program(testnative SRC "testnative.c" "testutils.c" "${TESTNATIVE_EXTRA}")
 if(UNIX AND NOT ANDROID AND NOT APPLE)
-  target_link_libraries(testnative PRIVATE X11)
+  if(NOT SDL2COMPAT_DISABLE_X11)
+    target_link_libraries(testnative PRIVATE X11)
+  endif()
 endif()
 test_program(testoverlay2 SRC "testoverlay2.c" "testutils.c" "testyuv_cvt.c")
 test_program(testplatform NONINTERACTIVE SRC "testplatform.c")
