=== debian/changelog ===
sdl2-compat (2.32.58+ds-1) unstable; urgency=medium

  * New upstream release
  * d/control, d/gbp.conf, d/watch: Move back to release branch

 -- Simon McVittie <smcv@debian.org>  Fri, 31 Oct 2025 16:39:32 +0000
