=== debian/control ===
--- 
+++ 
@@ -17,7 +17,7 @@
 Standards-Version: 4.7.2
 Section: libs
 Homepage: https://github.com/libsdl-org/sdl2-compat
-Vcs-Git: https://salsa.debian.org/sdl-team/sdl2-compat.git -b debian/snapshots
+Vcs-Git: https://salsa.debian.org/sdl-team/sdl2-compat.git
 Vcs-Browser: https://salsa.debian.org/sdl-team/sdl2-compat
 
 Package: libsdl2-compat
