=== debian/rules ===
--- 
+++ 
@@ -33,8 +33,8 @@
 	dh $@ -Scmake+ninja -Bcmake-build
 
 override_dh_auto_configure:
-ifeq ($(DEB_VERSION_UPSTREAM),2.32.56+git20251027~cec43be+ds)
-	echo release-2.32.56-62-gcec43be > REVISION.txt
+ifeq ($(DEB_VERSION_UPSTREAM),2.32.56+git20251029~ee7cf25+ds)
+	echo release-2.32.56-63-gee7cf25 > REVISION.txt
 endif
 	dh_auto_configure -- $(configure_options)
