=== debian/tests/control ===
Tests:
 build,
Depends:
 build-essential,
 clang:native,
 libsdl2-compat-dev,
Restrictions:
 allow-stderr,
 superficial,

Tests:
 deprecated-use,
Depends:
 build-essential,
 clang:native,
 libsdl2-compat-dev,
 libsdl2-ttf-dev,
Restrictions:
 allow-stderr,
 superficial,

Tests:
 cmake,
Depends:
 build-essential,
 cmake,
 libsdl2-compat-dev,
Restrictions:
 allow-stderr,
 superficial,

Tests:
 flaky,
Depends:
 libsdl2-compat-tests,
Restrictions:
 allow-stderr,
 flaky,
 superficial,

Tests:
 installed-tests,
Depends:
 gnome-desktop-testing,
 libsdl2-compat-tests,
Restrictions:
 allow-stderr,
