## sdl2-compat 2.32.60%2Bds

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -115,14 +115,14 @@
 elseif(WIN32)
   set(TESTNATIVE_EXTRA "testnativew32.c")
 elseif(UNIX AND NOT ANDROID)
-  if(NOT SDL2COMPAT_DISABLE_X11)
+  if(SDL2COMPAT_X11)
     find_package(X11 REQUIRED)
     set(TESTNATIVE_EXTRA "testnativex11.c")
   endif()
 endif()
 test_program(testnative SRC "testnative.c" "testutils.c" "${TESTNATIVE_EXTRA}")
 if(UNIX AND NOT ANDROID AND NOT APPLE)
-  if(NOT SDL2COMPAT_DISABLE_X11)
+  if(SDL2COMPAT_X11)
     target_link_libraries(testnative PRIVATE X11)
   endif()
 endif()
