=== debian/changelog ===
sdl2-compat (2.32.60+ds-3) experimental; urgency=medium

  * d/patches: Update to upstream git commit release-2.32.60-7-g3c72536
    (Closes: #1095774)
  * d/rules, d/libsdl2-dev.install: Don't enable the static library.
    This isn't available on non-Linux platforms, and isn't practically
    useful even on Linux, since the way sdl2-compat is implemented means
    that it always requires a shared SDL3.

 -- Simon McVittie <smcv@debian.org>  Fri, 19 Dec 2025 22:05:07 +0000

sdl2-compat (2.32.60+ds-2) experimental; urgency=medium

  * Switch the default SDL 2 from "classic" SDL 2 to sdl2-compat.
    This takes over the libsdl2-2.0-0 and libsdl2-dev package names from
    src:libsdl2, converting libsdl2-compat, libsdl2-compat-shim and
    libsdl2-compat-dev into transitional packages.
    Please see file:///usr/share/doc/libsdl2-2.0-0/README.Debian.gz
    for details of how individual games can be forced to use "classic"
    SDL 2 (in the libsdl2-classic package) if this causes a regression.
  * d/source/lintian-overrides: Update

 -- Simon McVittie <smcv@debian.org>  Wed, 17 Dec 2025 10:37:22 +0000

sdl2-compat (2.32.60+ds-1) unstable; urgency=medium

  * New upstream release
  * Refresh patch series (no functional change)

 -- Simon McVittie <smcv@debian.org>  Wed, 03 Dec 2025 13:47:14 +0000
