=== debian/rules ===
--- 
+++ 
@@ -50,19 +50,9 @@
 	rm -fv debian/tmp/usr/share/installed-tests/SDL2_compat/testtimer.test
 endif
 
-override_dh_strip:
-	dh_strip -plibsdl2-compat-shim --no-automatic-dbgsym
-	dh_strip --remaining-packages
-
 override_dh_makeshlibs:
 	dh_makeshlibs -plibsdl2-compat -n
 	dh_makeshlibs --remaining-packages
-	library=$$(cd debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH) && ls -1 libSDL2-2.0.so.0.*) && \
-	ln -fns sdl2-compat/$$library debian/libsdl2-compat-shim/usr/lib/$(DEB_HOST_MULTIARCH)/
-	ln -fns sdl2-compat/libSDL2-2.0.so.0 debian/libsdl2-compat-shim/usr/lib/$(DEB_HOST_MULTIARCH)/
-
-override_dh_shlibdeps:
-	dh_shlibdeps -lusr/lib/$(DEB_HOST_MULTIARCH)/sdl2-compat
 
 # debhelper >= 13.4 makes all of /usr/libexec executable, which is not
 # quite right for installed-tests
