=== debian/changelog ===
sdl2-compat (2.32.62+ds-3) unstable; urgency=medium

  * d/p/Filter-out-non-fullscreen-flags-when-setting-fullscreen.patch,
    d/p/tests-sync-with-latest-SDL2.patch,
    d/p/window-Set-grab-window-flags-even-if-grab-fails.patch:
    Add additional compatibility fixes from upstream

 -- Simon McVittie <smcv@debian.org>  Tue, 20 Jan 2026 20:24:56 +0000

sdl2-compat (2.32.62+ds-2) unstable; urgency=medium

  * d/control: Standards-Version: 4.7.3 (no changes required)
  * d/control: Remove unnecessary Priority field
  * d/upstream-signing-key.asc: Accept Sam's new signing key
  * Revert "Switch the default SDL 2 from "classic" SDL 2 to sdl2-compat".
    Let's have this new upstream version in unstable, even if we're not
    quite ready to make it the default yet.

 -- Simon McVittie <smcv@debian.org>  Tue, 20 Jan 2026 19:44:24 +0000

sdl2-compat (2.32.62+ds-1) experimental; urgency=medium

  * New upstream release
  * Drop most patches, applied upstream

 -- Simon McVittie <smcv@debian.org>  Thu, 01 Jan 2026 11:05:43 +0000
