## sdl2-compat 2.32.62+git20260122~1c8ece4+ds

=== debian/changelog ===
sdl2-compat (2.32.62+git20260122~1c8ece4+ds-1) experimental; urgency=medium

  * d/watch, d/watch.git, d/gbp.conf, d/source/lintian-overrides:
    Watch for git snapshots
  * New upstream git snapshot
    - Fix memory leaks when handing over externally-allocated pixel data
      to SDL, fixing a regression in the Moonlight game streaming client
      when using SDL_ttf
  * d/patches: Drop patches that are included in the upstream snapshot
  * d/copyright: Update

 -- Simon McVittie <smcv@debian.org>  Mon, 26 Jan 2026 14:32:24 +0000

sdl2-compat (2.32.62+ds-3+exp1) experimental; urgency=medium

  * d/gbp.conf, d/control: Use debian/snapshots branch for experimental
    until we are ready to make sdl2-compat the default
  * Reapply "Switch the default SDL 2 from "classic" SDL 2 to sdl2-compat".
    This takes over the libsdl2-2.0-0 and libsdl2-dev package names from
    src:libsdl2, converting libsdl2-compat, libsdl2-compat-shim and
    libsdl2-compat-dev into transitional packages.
    Please see file:///usr/share/doc/libsdl2-2.0-0/README.Debian.gz
    for details of how individual games can be forced to use "classic"
    SDL 2 (in the libsdl2-classic package) if this causes a regression.

 -- Simon McVittie <smcv@debian.org>  Tue, 20 Jan 2026 21:12:17 +0000
