=== debian/watch ===
Version: 5

Source: https://github.com/libsdl-org/sdl2-compat.git
Matching-Pattern: HEAD
Compression: xz
Dversion-Mangle: s/[+~](?:ds|dfsg)[0-9]*$//;s/\+(?:git)?[0-9]+(?:\+g[0-9a-f]*)?$//
Mode: git
Pgp-Mode: none
Git-Pretty: 2.32.62+git%cd~%h
Repack: yes
Repack-Suffix: +ds
